package org.apache.bcel.classfile;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.DataInput;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Iterator;
import java.util.stream.Stream;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.MethodParameter;
import org.apache.bcel.classfile.Visitor;

public class MethodParameters extends Attribute implements Iterable<MethodParameter> {
  private static final MethodParameter[] EMPTY_METHOD_PARAMETER_ARRAY = new MethodParameter[0];
  
  private MethodParameter[] parameters = EMPTY_METHOD_PARAMETER_ARRAY;
  
  MethodParameters(int nameIndex, int length, DataInput input, ConstantPool constantPool) throws IOException {
    super((byte)21, nameIndex, length, constantPool);
    int parameterCount = input.readUnsignedByte();
    this.parameters = new MethodParameter[parameterCount];
    for (int i = 0; i < parameterCount; i++)
      this.parameters[i] = new MethodParameter(input); 
  }
  
  public void accept(Visitor v) {
    v.visitMethodParameters(this);
  }
  
  public Attribute copy(ConstantPool constantPool) {
    org.apache.bcel.classfile.MethodParameters c = (org.apache.bcel.classfile.MethodParameters)clone();
    c.parameters = new MethodParameter[this.parameters.length];
    Arrays.setAll(c.parameters, i -> this.parameters[i].copy());
    c.setConstantPool(constantPool);
    return c;
  }
  
  public void dump(DataOutputStream file) throws IOException {
    super.dump(file);
    file.writeByte(this.parameters.length);
    for (MethodParameter parameter : this.parameters)
      parameter.dump(file); 
  }
  
  public MethodParameter[] getParameters() {
    return this.parameters;
  }
  
  public Iterator<MethodParameter> iterator() {
    return Stream.<MethodParameter>of(this.parameters).iterator();
  }
  
  public void setParameters(MethodParameter[] parameters) {
    this.parameters = parameters;
  }
}
